unit INITShellResident;
{Copyright  1990, David B. Lamkins}
{All rights reserved.}

{This unit must be compiled as a separate project, since code resource projects cannot have}
{multiple segments.  We need this to be in a separate segment from the INIT loader since we}
{depend upon the presence of a the standard code header as a place to stash a handle to any}
{globals we may need for the patch.  Also, it is much easier and safer to size and detach a}
{separate resource for the patch code than it is to play games with address arithmetic and}
{call _BlockMove to make a copy of the patch code.  By convention this code resource will}
{have a type of 'IRES' (see INITShellLoader).}

interface

	uses
		INITShellGlobals, InitShellInlines, Retrace;

	procedure main;

implementation

{$D-}
{$V-}
{$R-}

{This is the resident code.  It may have local variables.  Global data must be accessed through}
{the handle obtained from the GlobalsHandle function.  See the INITShellInlines unit for further}
{programming details.}
	procedure main;
	begin
	{Your code goes here}
	end;

end.