unit VM;

interface

	function GetPhysical (var addresses: LogicalToPhysicalTable; var physicalEntryCount: Longint): OSErr;
	inline
		$241F,	{MOVE.L (A7)+,D2}
		$2242,	{MOVEA.L D2,A1}
		$2251,	{MOVEA.L (A1),A1}
		$205F,	{MOVEA.L (A7)+,A0}
		$7005,	{MOVEQ #$05,D0}
		$A15C,	{_MemoryDispatch,A0}
		$3E80,	{MOVE.W D0,(A7)}
		$2242,	{ MOVEA.L D2,A1}
		$2288;	{MOVE.L A0,(A1)}

	function LockMemory (address: univ Ptr; count: Longint): OSErr;
	inline
		$225F,	{MOVEA.L (A7)+,A1}
		$205F,	{MOVEA.L (A7)+,A0}
		$7002,	{MOVEQ #$02,D0}
		$A05C,	{_MemoryDispatch}
		$3E80;	{MOVE.W D0,(A7)}

	function UnlockMemory (address: univ Ptr; count: Longint): OSErr;
	inline
		$225F,	{MOVEA.L (A7)+,A1}
		$205F,	{MOVEA.L (A7)+,A0}
		$7003,	{MOVEQ #$03,D0}
		$A05C,	{_MemoryDispatch}
		$3E80;	{MOVE.W D0,(A7)}

implementation
end.